#include "stdafx.h"
#include <fstream>
#include <iomanip>
#include <stack>
#include <vector>
#include "midi.h"
#include "endian.h"
using namespace std;

// [h ----------------------------------------------------------
//	MIDIt@Cǂݍ
int
Midi::Load (
	const char	*FilePath )											// (i)SMFt@CpX
{
	locale::global(locale("japanese"));								// Ȃ܂Ȃ
	// t@CI[v
	ifstream    ifs( FilePath, ios::in | ios::binary );				// t@CXg[
	if ( !ifs ) {
		cerr << "File OpenłȂ" << endl;
 		return -1;
	}
	// FileHeader
	FileHeader	fh;
	ifs.read( reinterpret_cast<char*>(&fh), FHSIZE );
	if ( !ifs ) {
		cerr << "File Header ǂݍ݂ŃG[" << endl;
 		return -1;
	}
	reverse_endian( fh.dwKeyWord );									// GfBA]
	if ( fh.dwKeyWord != 'MThd' ) {									// MIDIt@Cwb_"MThd"ł邱
		cerr << "File Header `N'MThd'FłȂA midit@CȂ" << endl;
 		return -1;
	}
	reverse_endian( fh.dwMainHeaderSize );							// GfBA]
	cerr << "; Main Header Size " << fh.dwMainHeaderSize << " byte." << endl;
	if ( MHSIZE > fh.dwMainHeaderSize								// ߂
			|| 0x1000 < fh.dwMainHeaderSize ) {						// ł߂
		cerr << "Main Header̃TCY(" << fh.dwMainHeaderSize << "BYTE)ُ킾H" << endl;
 		return -1;
	}
	// MainHeader
	MainHeader mh;
	ifs.read( reinterpret_cast<char*>(&mh), MHSIZE );
	if ( !ifs ) {
		cerr << "Main Header ǂݍ݂ŃG[" << endl;
 		return -1;
	}
	reverse_endian( mh.wFormat );									// GfBA]
	reverse_endian( mh.wTrackCount );
	reverse_endian( mh.wTimeBase );
	cerr << "; midi format "	<< mh.wFormat
		 << "\n; track count "	<< mh.wTrackCount
		 << "\n; Time base   "	<< mh.wTimeBase << endl;
	mFormat = mh.wFormat;											// tH[}bg
	mTimeBase = mh.wTimeBase;										// \

	ifs.seekg( FHSIZE + fh.dwMainHeaderSize, ios::beg );			// MainHeadeȑI܂œǂݔ΂
	if ( !ifs ) {
		cerr << "Main Header ̌オr؂Ă" << endl;
 		return -1;
	}
	// Track
	for ( WORD n = 0 ; n < mh.wTrackCount ; n++ ){
		cerr << "; Track " << n << "\t";
		// TrackHeader
		TrackHeader	th;												// gbNwb_
		ifs.read( reinterpret_cast<char*>(&th), THSIZE );
		if ( !ifs ) {
			cerr << "Track Header ǂݍ݂ŃG[" << endl;
	 		return -1;
		}
		reverse_endian( th.dwKeyWord );								// GfBA]
		if ( th.dwKeyWord != 'MTrk' ) {								// gbNwb_"MTrk"ł邱
			cerr << "Track Header `N'MTrk'FłȂAgbNĂ" << endl;
	 		return -1;
		}
		reverse_endian( th.dwTrackSize );							// GfBA]
		cerr << "Track Data Size " << th.dwTrackSize << " byte." << endl;
		// TrackData
		if ( Decode( ifs, th.dwTrackSize ) ) {						// gbN
			return -1;
		}
	}
	return 0;
}

// gbN
//	Xg[MIDI`PgbNǂgbNXg擾
int
Midi::Decode (														// t@CXg[ǂݍ݃gbN͂
	istream		&is,												// (i)̓Xg[
	const DWORD	&dwTrackSize)										// (i)gbNTCYigbN̏Iʒuɗpj
{
	list<Operate>	OpeList;
	BYTE		StatusBackup = 0x00;								// Xe[^XobNAbv
	streampos	LastPos = is.tellg();								// ݈ʒu
	LastPos += dwTrackSize;											// gbN̏Iʒu߂
	while ( LastPos > is.tellg() ) {								// gbN̏Iʒu܂Ń[v
		Operate			Ope;
		// f^^C擾
		Ope.Time = TimeDecode ( is );								// Ȑ擪̎Ԃ
		if ( 0 > Ope.Time) break;
		// Xe[^X擾
		is.read( reinterpret_cast<char*>(&(Ope.Status)), 1 );		// Xe[^X擾
		if ( !is ) {
			cerr << "Status ǂݍ݂ŃG[" << endl;
			break;
		}
		// jOXe[^X̏
		// QlFhttp://www2s.biglobe.ne.jp/~yyagi/material/smfspec.html#RunningStatus
		BYTE &Status = reinterpret_cast<BYTE&>( Ope.Status );		// Alius
		if ( 0x80 & Status ) {										// Xe[^XȗĂȂ
			StatusBackup = Status;									// Xe[^XobNAbv
		} else {													// Xe[^XȗĂ
			Status = StatusBackup;									// ÕXe[^Xŕ⊮
			is.seekg( -1, ios::cur );								// 1oCg߂
		}
		// Xe[^Xʏ
		switch ( 0xF0 & Status ) {									// Xe[^X
		// 2ByteStatus
		case 0xC0:	// vO`FW
		case 0xD0:	// `lvbV[
			is.read( reinterpret_cast<char*>(&(Ope.Status1)), 1 );	// Xe[^X1擾
			if ( !is ) break;
			OpeList.push_back( Ope );								// Xgɒǉ
			break;
		// 3ByteStatus
		case 0x80:	// m[gIt
		case 0x90:	// m[gI
		case 0xA0:	// |tHjbNL[vbV[
		case 0xB0:	// Rg[`FW
		case 0xE0:	// sb`xh
			is.read( reinterpret_cast<char*>(&(Ope.Status1)), 1 );	// Xe[^X1擾
			if ( !is ) break;
			is.read( reinterpret_cast<char*>(&(Ope.Status2)), 1 );	// Xe[^X2擾
			if ( !is ) break;
			OpeList.push_back( Ope );								// Xgɒǉ
			break;
		// ControlStatus
		case 0xF0:	// VXeSysEx
			if ( 0xFF == Status ) {									// ^CxgȂ
				is.read( reinterpret_cast<char*>(&(Ope.Status1)), 1 );// Xe[^X1擾
				if ( !is ) break;
			}
			{
				long lCount = static_cast<long>( TimeDecode ( is ) );// bZ[W擾
				if ( 0 > lCount ) break;
				char* p= new char[lCount] ;							// Ɨ̈m
				is.read( p, lCount );								// VXeSysEx擾
				Ope.ExData.assign( p, lCount );						// i[
				delete[] p;
				if ( !is ) break;
			}
			// eLXg\
			switch ( Ope.Status1 ) {								// Xe[^X1eLXgȂ
			case 0x01:	// eLXg
			case 0x02:	// 쌠\
			case 0x03:	// Ȗ/gbN
			case 0x04:	// y햼
			case 0x05:	// ̎
			case 0x08:	// vO(F)
			case 0x09:	// foCX()
				if ( !Ope.ExData.empty() ) {						// 󂶂Ȃ
					if ( '\0' == Ope.ExData[ Ope.ExData.length()-1 ] ) {// NULL폜
						Ope.ExData = Ope.ExData.substr( 0, Ope.ExData.length()-1 );
					}
				}
				if ( !Ope.ExData.empty() ) {						// 󂶂Ȃ
					char *TextName[]={								// eLXg
						"V[PXԍ",
						"eLXg",
						"쌠\",
						"Ȗ/gbN",
						"y햼",
						"̎",
						"}[J[",
						"L[|Cg",
						"vO(F)",
						"foCX()",
					};
					cerr << TextName[Ope.Status1]					// eLXg
						 << ":\"" << Ope.ExData.c_str() << "\"" << endl;// eLXg\
					OpeList.push_back( Ope );						// Xgɒǉ
				}
				break;
			case 0x2F:	// gbNȈꍇ
				OpeList.push_back( Ope );							// Xgɒǉ
				mTrackList.push_back( OpeList );					// 䃊XggbNXgɒǉ
				OpeList.clear();									// 䃊XgNA
				break;
			default:
				OpeList.push_back( Ope );							// Xgɒǉ
			}
			break;
		default:	// MIDItH[}bgُ
			cerr << "x:MIDItH[}bgُ Status("
				 << hex << (WORD)Status << ")s" << endl;
			break;	// ͋s
		}
		if ( !is ) {												// ǂݍ݃G[o
			cerr << "ǂݍ݃G[Amidit@CĂ܂񂩁H" << endl;
			break;
		}
	}
	// gbNXgɒǉ
	if ( !OpeList.empty() ) {										// 䃊XgɉcĂ
		mTrackList.push_back( OpeList );							// 䃊XggbNXgɒǉ
	}
	return ( !is ? -1: 0 );											// G[Ȃ-1
}

// f^^C
//	Xg[f^^CǂԂ擾B
DWORD
Midi::TimeDecode (													// t@CXg[ǂݍ݃f^^C͂ԂԂ
	istream		&is)												// (i)̓Xg[
{
	register DWORD	Time(0);
	register BYTE	Data;
	do {
		is.read( reinterpret_cast<char*>(&Data), 1 );
		if ( !is ) {												// G[Ȃ
			cerr << "f^^Cǂݍ݂ŃG[Amidit@CĂ܂񂩁H" << endl;
			return -1;												// -1Ԃ
		}
		Time = ( Time << 7 ) | ( Data & 0x7F );
	} while ( Data & 0x80 );
	return Time;													// ԂԂ
}

// Z[u ----------------------------------------------------------
//	MIDIt@Cɕۑ
int
Midi::Save (
	const char	*FilePath )											// (i)SMFt@CpX
{
	// ΎԂɐݒ
	ChengeTimeType( TT_RELATIVE );									// ΎԂɕύX
	// ȂȂȂ
	locale::global(locale("japanese"));								// ȂȂȂ
	// t@CI[v
	ofstream    ofs( FilePath, ios::out | ios::binary );			// t@CXg[
	if ( !ofs ) {
		cerr << "File OpenłȂ" << endl;
 		return -1;
	}
	// FileHeader
	FileHeader	fh;
	fh.dwKeyWord = convert_endian( 'MThd' );						// t@Cwb_`Nʂݒ
	fh.dwMainHeaderSize = convert_endian( MHSIZE );					// MainHeaderTCYݒ
	ofs.write( reinterpret_cast<char*>(&fh), FHSIZE );
	if ( !ofs ) {
		cerr << "File Header o͂ŃG[" << endl;
 		return -1;
	}
	// MainHeader
	MainHeader	mh;
	mh.wFormat		= convert_endian( mFormat );					// tH[}bgPɐݒ
	WORD TrackCount	= mTrackList.size();							// gbN
	mh.wTrackCount	= convert_endian( TrackCount );					// gbNݒ
	mh.wTimeBase	= convert_endian( mTimeBase );					// \ݒ
	ofs.write( reinterpret_cast<char*>(&mh), MHSIZE );
	if ( !ofs ) {
		cerr << "Main Header o͂ŃG[" << endl;
 		return -1;
	}
	// Track
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt ) {												// Ce[^i߂
		// TrackData
		// FgbNTCYɋ߂Kv邽߁AɃgbNf[^𕄍Ăit@Co͂͌Łj
		stringstream ss;											// ꎞ̈
		if ( 0 > Encode( ss, *TrackIt ) ) {							// gbNf[^
			cerr << "gbNGR[hŃG[" << endl;
			return -1;
		}
		int TrackSize = ss.tellp();									// gbNTCY擾
		if ( 0 > TrackSize ) {										// }CiXlȂgbNȂ̂
			continue;												// o͂ÃgbN
		}
		// TrackHeader
		TrackHeader	th;												// gbNwb_
		th.dwKeyWord	= convert_endian( 'MTrk' );					// gbNwb_`Nʂݒ
		th.dwTrackSize	= convert_endian( TrackSize );				// gbNTCYݒ
		ofs.write( reinterpret_cast<char*>(&th), THSIZE );
		if ( !ofs ) {
			cerr << "Track Header o͂ŃG[" << endl;
			return -1;
		}
		// gbNf[^t@Cɗ
		ofs << ss.str() << flush;									// ꎞ̈t@Cɏo
		if ( !ofs ) {
			cerr << "Track Data o͂ŃG[" << endl;
			return -1;
		}
	}
	return ( !ofs ? -1: 0 );										// G[Ȃ-1
}

// gbN
//	PgbN̐䃊XgMIDI`̃f[^ɕϊXg[ɏo͂
int
Midi::Encode(														// gbNf[^𕄍ꎞ̈Ɋi[
		ostream		  &os,											// (o)o̓Xg[
		list<Operate> &OpeList)										// (i)䃊Xg
{
	BYTE	StatusBackup(0x00);										// Xe[^XobNAbv
	// 䃊Xg[v
	for ( list<Operate>::iterator OpeIt = OpeList.begin();			// Ce[^ɐ䃊Xg̐擪Zbg
		  OpeIt != OpeList.end();									// 䃊Xg̍Ō܂
		  ++OpeIt ) {												// Ce[^i߂
		// o͏
		Operate &Ope = *OpeIt;										// 
		TimeEncode( os, Ope.Time );									// Ԃ𕄍
		if ( !os ) return -1;
		BYTE &Status = reinterpret_cast<BYTE&>( Ope.Status );		// Alius
		// jOXe[^X̏
		if (StatusBackup != Status ) {								// Xe[^XOƈႤȂ
			StatusBackup = Status;									// Xe[^XobNAbv
			os.write( reinterpret_cast<char*>(&Ope.Status), 1);		// Xe[^Xo
			if ( !os ) return -1;
		}
		// Xe[^Xʏ
		switch ( 0xF0 & Status ) {
		// 2ByteStatus
		case 0xC0:	// vO`FW
		case 0xD0:	// `lvbV[
			os.write( reinterpret_cast<char*>(&(Ope.Status1)), 1 );	// Xe[^X1o
			if ( !os ) return -1;
			break;
		// 3ByteStatus
		case 0x80:	// m[gIt
		case 0x90:	// m[gI
		case 0xA0:	// |tHjbNL[vbV[
		case 0xB0:	// Rg[`FW
		case 0xE0:	// sb`xh
			os.write( reinterpret_cast<char*>(&(Ope.Status1)), 1 );	// Xe[^X1o
			if ( !os ) return -1;
			os.write( reinterpret_cast<char*>(&(Ope.Status2)), 1 );	// Xe[^X2o
			if ( !os ) return -1;
			break;
		// ControlStatus
		case 0xF0:	// VXeSysEx
			StatusBackup = 0x00;									// jOXe[^XɂȂ
			if ( 0xFF == Status ) {									// ^CxgȂ
				os.write( reinterpret_cast<char*>(&(Ope.Status1)), 1 );// Xe[^X1o
				if ( !os ) return -1;
			}
			TimeEncode( os, Ope.ExData.size() );					// bZ[Wo
			if ( !os ) return -1;
			os.write( Ope.ExData.c_str(), Ope.ExData.size() );		// VXeSysExo
			if ( !os ) return -1;
		}
	}
	return 0;														// 
}
// f^^C
//	Ԃf^^CɕϊXg[ɏo͂
int
Midi::TimeEncode (													// Ԃf^^CɕXg[ɏo͂
		ostream		&os,											// (o)o̓Xg[
		DWORD		Time)											// (i)
{
	// ʃrbgX^bNɐς
	stack<BYTE>		stk;											// X^bN
	bool			final( TRUE );									// Ōɐݒ
	register BYTE	data;
	do {
		data = Time & 0x7F;											// Vrbgo
		Time >>= 7;													// TimeVrbgl߂
		if ( final ) {												// ŌȂ
			final = FALSE;											// rɐݒ
		} else {													// rȂ
			data |= 0x80;											// ̃rbg𗧂Ă
		}
		stk.push( data );											// X^bNɐς
	} while ( Time );												// TimeLȂ܂Ń[v
	// tɏo
	while ( !stk.empty() ) {										// ɂȂ܂Ń[v
		data = stk.top();											// X^bN擾
		os.write( reinterpret_cast<char*>(&data), 1 );				// o
		if ( !os ) {												// G[Ȃ
			cerr << "f^^Co͂ŃG[" << endl;
			return -1;												// -1Ԃ
		}
		stk.pop();													// X^bN甲
	}
	return 0;
}

// ԐLk --------------------------------------------------------
//	TimeBasei\j͕ύXASCxg̎Ԃ𓯔䗦ŐLk܂B
//	gpړI͏߂Ɖ̔䗦ĂȂꍇ̕␳łB
void
Midi::TimeExpand  (													// gbN̎ԂL
	const float	&Ratio )											// (i)Lk
{
	ChengeTimeType(TT_RELATIVE);									// ΎԂɂĂ
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt ) {												// Ce[^i߂
		double	sum(0),												// ώZ
				ex_sum(0);											// ώZԐLkl
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ++OpeIt ) {											// Ce[^i߂
			// ԂLk
			// Lkɂ鎞Ԃ̃Y邽߁AȐ擪̎ԂߐLks
			Operate &Ope = *OpeIt;
			sum += Ope.Time;										// ώZԂɍ̎ԂZ
			double	now_ex_sum = sum * Ratio;						// ̐ώZԐLklvZ
			Ope.Time = static_cast<DWORD>( now_ex_sum )				// ƑO̐ώZԐLkl̍VԂƂ
					 - static_cast<DWORD>( ex_sum );				// ۂߏlō̂Y~\
			ex_sum = now_ex_sum;									// ̐ώZԐLklۊ
			// e|␳
			// ԂLkƋȂ̑xς邽߁Ae|␳
			// QlFhttp://www2s.biglobe.ne.jp/~yyagi/material/smfspec.html#tempo
			if ( (0xFF == Ope.Status) && (0x51 == Ope.Status1) ) {	//e|CxgȂ
				DWORD	tempo
					= (static_cast<BYTE>(Ope.ExData[0]) << 16)		// e|o
					| (static_cast<BYTE>(Ope.ExData[1]) << 8)
					|  static_cast<BYTE>(Ope.ExData[2]);
				tempo= static_cast<DWORD>(1 / Ratio * tempo);		// e|Lk
				Ope.ExData[0] = static_cast<char>(tempo >> 16);		// e|i[
				Ope.ExData[1] = static_cast<char>(tempo >> 8);
				Ope.ExData[2] = static_cast<char>(tempo);
			}
		}
	}
}
// \ύX
//	TimeBasei\jƁAɍ킹SCxg̎Ԃ𓯔䗦ŕύX܂B
//	̊Iɂ͕\͍Œ 24 炢EłȉɂƉ̔ȃYBiȂ̃e|ɂj
void
Midi::ChangeResolution (											// \ύX
	const WORD	&NewTimeBase )										// (i)V\
{
	double Ratio = static_cast<double>(NewTimeBase) / mTimeBase;	// LkvZ
	ChengeTimeType(TT_RELATIVE);									// ΎԂɂĂ
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt ) {												// Ce[^i߂
		double	sum(0),												// ώZ
				ex_sum(0);											// ώZԐLkl
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ++OpeIt ) {											// Ce[^i߂
			// ԂLk
			// Lkɂ鎞Ԃ̃Y邽߁AȐ擪̎ԂߐLks
			Operate &Ope = *OpeIt;
			sum += Ope.Time;										// ώZԂɍ̎ԂZ
			double	now_ex_sum = sum * Ratio;						// ̐ώZԐLklvZ
			Ope.Time = static_cast<DWORD>( now_ex_sum )				// ƑO̐ώZԐLkl̍VԂƂ
					 - static_cast<DWORD>( ex_sum );				// ۂߏlō̂Y~\
			ex_sum = now_ex_sum;									// ̐ώZԐLklۊ
		}
	}
	mTimeBase = NewTimeBase;										// V\ɍXV
}

// ԃ^CvύX --------------------------------------------------
//	SCxg̎ԏAΎԁ^ΎԂɕύXBiMIDIt@C̓ftHgőΎԁj
void
Midi::ChengeTimeType (												// ԃ^CvύX
	const TIMETYPE	&NewTimeType )									// (i)Vԃ^Cv FALSE:Ύ TRUE:Ύ
{
	if ( NewTimeType == mTimeType )	return;							// ύXȂ΋A
	// ΎԂɕύXꍇ
	if ( NewTimeType ) {
		// gbNXg[v
		for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
			  TrackIt != mTrackList.end();							// gbN̍Ō܂
			  ++TrackIt ) {											// Ce[^i߂
			DWORD	sum(0);											// Ύ
			// 䃊Xg[v
			for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();// Ce[^ɐ䃊Xg̐擪Zbg
				  OpeIt != (*TrackIt).end();						// 䃊Xg̍Ō܂
				  ++OpeIt ) {										// Ce[^i߂
				Operate &Ope = *OpeIt;
				sum += Ope.Time;									// ΎԂɑΎԂZ
				Ope.Time = sum;										// ΎԂi[
			}
		}
	}
	// ΎԂɕύXꍇ
	else {
		// gbNXg[v
		for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
			  TrackIt != mTrackList.end();							// gbN̍Ō܂
			  ++TrackIt ) {											// Ce[^i߂
			DWORD	last(0);										// O̎
			// 䃊Xg[v
			for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();// Ce[^ɐ䃊Xg̐擪Zbg
				  OpeIt != (*TrackIt).end();						// 䃊Xg̍Ō܂
				  ++OpeIt ) {										// Ce[^i߂
				Operate &Ope = *OpeIt;
				register DWORD	now = Ope.Time;						// ΎԂޔ
				Ope.Time -= last ;									// ΎԂ͍񂩂OԂi[
				last = now;											// ̑OΎԂɍΎԂZbg
			}
		}
	}
	mTimeType = NewTimeType;										// ړI̎ԃ^CvZbg
}

// tH[}bgύX ------------------------------------------------
//	tH[}bgO^P̕ύXsB
//	tH[}bgOł͑SgbN擪gbNɃ}[WB
//	tH[}bgPł̓Cxg`lʂɕނgbNsB
//		̏ꍇVXeSysEx̓`lȂ߁A
//		gbN̑̃CxgƓ`lɕނB
//		gbN̑̃CxgꍇɂConductorTracki擪gbNjɕނB
//		Ae|ݒEq̐ݒ̏ꍇ͋IConductorTracki擪gbNjɕނB
void
Midi::ChengeFormat (												// tH[}bgύX
	const WORD	&Format )											// (i)tH[}bg
{
	// ΎԂɐݒ
	ChengeTimeType( TT_ABSOLUTE );									// ΎԂɕύX
	// tH[}bgOɕύX----
	if ( 0 == Format ) {
		// QԃgbNȍ~擪gbNɃ}[W
		list<list<Operate>>::iterator FirstTrackIt = mTrackList.begin();// 擪gbN
		(*FirstTrackIt).sort();
		list<list<Operate>>::iterator TrackIt = FirstTrackIt;		// ȍ~̃gbN
		for ( ++TrackIt; TrackIt != mTrackList.end();	) {			// gbN폜ɂOɋl߂邽iti߂KvȂ
			(*TrackIt).sort();
			(*FirstTrackIt).merge( *TrackIt );						// 擪gbNɃ}[W
			TrackIt = mTrackList.erase( TrackIt );					// svɂȂgbNj
		}
		mFormat = 0;												// tH[}bgOɂ
	}
	// tH[}bgPɕύX----
	else if ( 1 == Format ) {
		// gbNɂSĂ̐`lɕނڂς
		list<Operate>	ChList[17];									// `lXg
		// gbNXg[v
		for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
			  TrackIt != mTrackList.end();							// gbN̍Ō܂
			  ++TrackIt ) {											// Ce[^i߂
			// ԑ`lÃgbÑ`lƂ
			int	 ThisCh(0);											// ԑ`l
			if ( mFormat == 1 ) {									// tH[}bgP
				DWORD ChCnt[16]={0};								// `lJE^
				// 䃊Xg[v
				for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();// Ce[^ɐ䃊Xg̐擪Zbg
					  OpeIt != (*TrackIt).end();					// 䃊Xg̍Ō܂
					  ++OpeIt ) {									// Ce[^i߂
					if ( 0xF0 != (0xF0 & (*OpeIt).Status) ) {		// VXeSysExȊOȂ
						++ChCnt[(0xF & (*OpeIt).Status)];			// `l𐔂
					}
				}
				// ԑ`l
				DWORD	ChMax(0);									// `lől
				for ( int ch = 0; ch < 16; ++ch ) {					// S`l[v
					if ( ChMax < ChCnt[ch] ) {						// ől葽
						ChMax = ChCnt[ch];							// őlXV
						ThisCh = ch+1;								// ԑ`lXV
					}
				}
			}
			// `lɕނ
			for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();// Ce[^ɐ䃊Xg̐擪Zbg
				  ! (*TrackIt).empty();								// 䃊XgɂȂ܂
				  OpeIt = (*TrackIt).begin() ) {					// Ce[^ɐ䃊Xg̐擪Zbg
				int ch;
				BYTE Sta = 0xF0 & (*OpeIt).Status;
				if ( 0xF0 == Sta ) {								// VXeSysExȂ
					if ( (0xFF == (*OpeIt).Status) &&				// ^Cxg
						 ( (0x06 == (*OpeIt).Status1) ||			// }[J[@܂
						   (0x51 == (*OpeIt).Status1) ||			// e|ݒ@܂
						   (0x58 == (*OpeIt).Status1) )	) {			// q̐ݒ@Ȃ
						ch = 0;										// Conductor Trackɕ
					} else {										// ȊOȂ
						ch = ThisCh;								// ̃gbÑ`lɕ
					}
				} else {											// VXeSysExȊO
					ch = (0xF & (*OpeIt).Status) +1;				// Xe[^X̉Srbg`l
				}
				ChList[ch].splice( ChList[ch].end(), *TrackIt, OpeIt );// gbNXg`lXgɐڂ
			}
		}
		// gbNXgNA
		mTrackList.clear();
		// S`lgbNɖ߂
		for ( int ch = 0; ch < 17; ++ch ) {							// S`l[v
			if ( ! ChList[ch].empty() ) {							// ̃`l󂶂Ȃ
				ChList[ch].sort();									// \[g
				mTrackList.push_back( ChList[ch] );					// gbNɃ`lǉ		()
				ChList[ch].clear();									// ̃`lNA
			}
		}
		mFormat = 1;												// tH[}bgPɂ
	}
	// gbNGhtւ
	AppendAllTrackEnd ( DeleteAllTrackEnd() );						// gbNGhtւ
}
// SgbNGh폜AyуgbNŌ̎Ԃ̎
//	SgbNGh폜ASgbÑCxgōŌƂȂ鎞Ԃ̎悷B
DWORD																// ߂lFgbNŌ̎
Midi::DeleteAllTrackEnd ( void )									// SgbNGh폜AyуgbNŌ̎Ԃ̎
{
	// ΎԂɐݒ
	ChengeTimeType( TT_ABSOLUTE );									// ΎԂɕύX
	// gbNXg[v
	DWORD LastTime(0);												// Ō̎
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt ) {												// Ce[^i߂
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ) {													// ł̓Ce[^i߂Ȃ
			Operate &Ope = *OpeIt;
			if ( LastTime < Ope.Time ) {							// Ō̎ԂȂ
				LastTime = Ope.Time;								// XV
			}
			if ( (0xFF == Ope.Status) && (0x2F == Ope.Status1) ) {	// gbNGhȂ
				OpeIt = (*TrackIt).erase( OpeIt );					// 폜
			} else {												// ȊOȂ
				++OpeIt;											// Ce[^i߂
			}
		}
	}
	return ( LastTime );											// gbNŌ̎
}

// SgbNgbNGhǉ
//	SgbNɃgbNGhǉB
void
Midi::AppendAllTrackEnd (											// SgbNgbNGhǉ
	const DWORD		&LastTime )										// (i)gbNGh
{
	// ΎԂɐݒ
	ChengeTimeType( TT_ABSOLUTE );									// ΎԂɕύX
	Operate TrackEnd( LastTime, 0xFF, 0x2F );						// gbNGh쐬
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt ) {												// Ce[^i߂
		(*TrackIt).push_back( TrackEnd );							// gbNGhǉ
	}
}

// SysEx폜 -------------------------------------------------------
//	SysEx폜[hɑΉނSysEx폜B
//		0x0:폜Ȃ
//		0x1:TEXT폜(^CgȊO)(FF,01`1F)
//		0x2:qE폜(FF,58E59)
//		0x4:@ˑCxg폜(F0`FEFF,7F)
//		0x8:̑e|SysEx̍폜(FF,00E20`50E52`7E)ɖȂȂ댯
// e[h̓rbgɑΉ̃[h𓯎gp\
void
Midi::DeleteSysEx (													// SysEx폜
	const WORD		Mode )											// (i)SysEx폜[h
{
	if ( 0 == Mode ) return;										// [hOȂ폜Ȃ
	// ΎԂɐݒ
	ChengeTimeType( TT_ABSOLUTE );									// ΎԂɕύX
	string Title;													// ^Cg
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt ) {												// Ce[^i߂
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ) {													// ł̓Ce[^i߂Ȃ
			Operate &Ope = *OpeIt;
			BYTE	Sta = 0xF0 & Ope.Status;						// Cxgo
			if ( 0xF0 != Sta ) {									// SysExȊO
				++OpeIt;											// 䃊Xg̃Ce[^i߂
				continue;											// ̐
			}
			else if ( 0xFF == Ope.Status ) {						// ^CxgȂ
				switch ( Ope.Status1 ) {							// Xe[^XP
				case 0x03:	// Ȗ/gbN
					if ( Title.empty() ) {							// ^Cg擾Ȃ
						Title = Ope.ExData;							// ^Cg
						++OpeIt;									// Ce[^i߂
						break;										// ̃^Cg͎c
					}
					// ^Cg擾ς݂Ȃ瑱s
				case 0x01:	// eLXg
				case 0x02:	// 쌠\
				case 0x04:	// y햼
				case 0x05:	// ̎
				case 0x08:	// vO(F)
				case 0x09:	// foCX()
				case 0x0A:
				case 0x0B:
				case 0x0C:
				case 0x0D:
				case 0x0E:
				case 0x0F:
				case 0x10:
				case 0x11:
				case 0x12:
				case 0x14:
				case 0x15:
				case 0x18:
				case 0x19:
				case 0x1A:
				case 0x1B:
				case 0x1C:
				case 0x1D:
				case 0x1E:
				case 0x1F:
					if ( 0x1 & Mode )								// [hPȂ
						OpeIt = (*TrackIt).erase( OpeIt );			// 폜
					else											// ȊOȂ
						++OpeIt;									// 䃊Xg̃Ce[^i߂
					break;
				case 0x58:	// q
				case 0x59:	// 
					if ( 0x2 & Mode )								// [hQȂ
						OpeIt = (*TrackIt).erase( OpeIt );			// 폜
					else											// ȊOȂ
						++OpeIt;									// 䃊Xg̃Ce[^i߂
					break;
				case 0x7F:	// V[PT胁^Cxg
					if ( 0x4 & Mode )								// [hSȂ
						OpeIt = (*TrackIt).erase( OpeIt );			// 폜
					else											// ȊOȂ
						++OpeIt;									// 䃊Xg̃Ce[^i߂
					break;
				case 0x51:	// e|ݒ
					if ( TrackIt != mTrackList.begin() )			// 擪gbNȊO
						OpeIt = (*TrackIt).erase( OpeIt );			// 폜
					else
						++OpeIt;									// 䃊Xg̃Ce[^i߂
					break;
				case 0x2F:	// gbNGh
					++OpeIt;										// 䃊Xg̃Ce[^i߂
					break;
				default:	// ȊO
					if ( 0x8 & Mode )								// [hWȂ
						OpeIt = (*TrackIt).erase( OpeIt );			// 폜
					else											// ȊOȂ
						++OpeIt;									// 䃊Xg̃Ce[^i߂
					break;
				}
			} else {												// ^CxgȊOSysExȂ
				if ( 0x4 & Mode )									// [hSȂ
					OpeIt = (*TrackIt).erase( OpeIt );				// 폜
				else												// ȊOȂ
					++OpeIt;										// 䃊Xg̃Ce[^i߂
			}
		}
	}
}
// gp폜
//	܂SysEx`lΏۂƂ閳ʂȐ폜B
//	܂AvO`FWRg[`FWgpĂ̂ɉꍇ
//	ݒ肷Ӗ͖Aʂȃf[^Ȃ̂ō폜B
//	ɂ́AvO`FWRg[`FW̑Ώۃ`lƁA
//	gbNĂĂ`lΏۂƂ鉹Ȃ΁A͍̐폜ȂB
void
Midi::DeleteUnusedOperate ( void )									// gp폜
{
	// ΎԂɐݒ
	ChengeTimeType( TT_ABSOLUTE );									// ΎԂɕύX
	// `l̉JEg
	int ChCnt[16]={0};												// `l̉
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt ) {												// Ce[^i߂
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ++OpeIt ) {											// Ce[^i߂
			Operate &Ope = *OpeIt;
			BYTE	Sta = 0xF0 & Ope.Status;						// Cxgo
			if ( (0x90 == Sta) ||									// m[gI ܂
				 (0x80 == Sta) ) {									// m[gIt Ȃ
				++ChCnt[0xF & Ope.Status];							// ̃`l̉JEg
			}
		}
	}
	// gp`lΏۂƂgbN폜
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt) {												// Ce[^i߂
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ) {													// ł̓Ce[^i߂Ȃ
			Operate &Ope = *OpeIt;
			BYTE	Sta = 0xF0 & Ope.Status;						// Cxgo
			if ( (0x90 == Sta) ||									// m[gI ܂
				 (0x80 == Sta) ||									// m[gIt ܂
				 (0xF0 == Sta) ) {									// SysExȂ
				++OpeIt;											// 䃊Xg̃Ce[^i߂
			}
			else if ( ChCnt[0xF & Ope.Status] ) {					// ȊOȂ ̃`lɉ
				++OpeIt;											// 䃊Xg̃Ce[^i߂
			} else {												// ̃`lɉ
				OpeIt = (*TrackIt).erase( OpeIt );					// ̐폜
			}
		}
	}
}
// gbN폜
//	CxggbNA܂̓gbNGhȂgbN폜B
void
Midi::DeleteEmptyTrack ( void )										// gbN폜
{
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		) {															// ł̓Ce[^i߂Ȃ
		if ( (*TrackIt).empty() ) {									// gbNȂ
			TrackIt = mTrackList.erase( TrackIt ) ;					// ̃gbN폜
		} else {
			list<Operate>::iterator OpeIt = (*TrackIt).begin();		// Ce[^ɐ䃊Xg̐擪Zbg
			Operate &Ope = *OpeIt;
			if ( (0xFF == Ope.Status) && (0x2F == Ope.Status1) ) {	// 擪gbNGhȂgbNȂ̂
				TrackIt = mTrackList.erase( TrackIt ) ;				// ̃gbN폜
			} else {												// ȊOȂ
				++TrackIt;											// gbNCe[^i߂
			}
		}
	}
}
// m[gGh\ύX --------------------------------------------
//	m[gGh̕\ 0x80 ܂ 0x90xVeBO ؂ւ
void
Midi::ChengeNoteEndType (											// m[gGh\ύX
	const WORD		NewNoteEnd )									// (i)Vm[gGh\ 0x80 / 0x90
{
	// m[gGh\ 0x80 ɕύXꍇ
	if ( 0x80 == NewNoteEnd ) {
		// gbNXg[v
		for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
			  TrackIt != mTrackList.end();							// gbN̍Ō܂
			  ++TrackIt ) {											// Ce[^i߂
			// 䃊Xg[v
			for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();// Ce[^ɐ䃊Xg̐擪Zbg
				  OpeIt != (*TrackIt).end();						// 䃊Xg̍Ō܂
				  ++OpeIt ) {										// Ce[^i߂
				Operate &Ope = *OpeIt;
				BYTE	Sta = 0xF0 & Ope.Status;					// Cxgo
				if ( (0x90 == Sta) && (0x00 == Ope.Status2) ) {		// m[gGh 0x90xVeBOȂ
					Ope.Status = 0x80 | (0xF & Ope.Status);			// m[gGh 0x80ɕύX
				}
			}
		}
	}
	// m[gGh\ 0x90xVeBO ɕύXꍇ
	else {
		// gbNXg[v
		for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
			  TrackIt != mTrackList.end();							// gbN̍Ō܂
			  ++TrackIt ) {											// Ce[^i߂
			// 䃊Xg[v
			for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();// Ce[^ɐ䃊Xg̐擪Zbg
				  OpeIt != (*TrackIt).end();						// 䃊Xg̍Ō܂
				  ++OpeIt ) {										// Ce[^i߂
				Operate &Ope = *OpeIt;
				BYTE	Sta = 0xF0 & Ope.Status;					// Cxgo
				if ( 0x80 == Sta ) {								// m[gGh 0x80Ȃ
					Ope.Status = 0x90 | (0xF & Ope.Status);			// m[gGh 0x90ɕύX
					Ope.Status2 = 0x00;								// xVeBOɕύX
				}
			}
		}
	}
}

// dgbN ------------------------------------------
//	̑OdꍇɃgbNB
//	AǍiKjdꍇɂ́Ả؂l߁AdȂԂɂB
void
Midi::DivideRepeatNote ( void )										// dgbN
{
	// ΎԂɐݒ
	ChengeTimeType( TT_ABSOLUTE );									// ΎԂɕύX
	// gbNXg[v
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ) {														// ł̓gbNCe[^͐i߂Ȃ
		enum {
			C_IDLE,													// 
			C_SEARCHSUBJECTNOTEOFF,									// ΏۉItT
			C_SEARCHREPEATNOTE,										// dT
			C_SEARCHREPEATNOTEOFF,									// dItT
		} Condition ( C_IDLE );										// 
		list<Operate>::iterator	SubjectNoteOn;						// Ώۉm[gÏʒu
		list<Operate>::iterator	SubjectNoteOff;						// Ώۉm[gIẗʒu
		DWORD					SubjectTailTime;					// Ώۉ̐Kԁiȍ~ɉdK؂藎Ƃj
		list<Operate>			RepeatTrack;						// dpgbN
		BYTE					RepeatKey;							// d̃L[
		DWORD					LastTime;							// gbNŌ̎
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ++OpeIt ) {											// Ce[^i߂
			Operate	&Ope = *OpeIt;
			LastTime = Ope.Time;									// gbNŌ̎ԂXV
			BYTE	Status = 0xF0 & Ope.Status;						// Cxgo
			switch ( Condition ) {									// 
			case C_IDLE:	// 
				switch ( Status ) {									// Cxg
				case 0x90:	// m[gIiΏۉj
					if ( 0 < Ope.Status2 ) {						// xVeBOȊOȂ
						Condition = C_SEARCHSUBJECTNOTEOFF;			// ΏۉItTԂɈڍs
						SubjectNoteOn = OpeIt;						// Ώۉm[gÏʒuL^
						break;
					}
					// xVeBOȂm[gItȂ̂Łs
				case 0x80:	// m[gIt
					cerr << "ԂŃm[gIm[gIt܂" << endl;
					break;
				}
				break;
			case C_SEARCHSUBJECTNOTEOFF:	// ΏۉItT
				switch ( Status ) {									// Cxg
				case 0x90:	// m[gI
					if ( 0 < Ope.Status2 ) {						// xVeBOȊOȂ
						break;
					}
					// xVeBOȂm[gItȂ̂Łs
				case 0x80:	// m[gIt
					if ( Ope.Status1 == (*SubjectNoteOn).Status1 ) {// Ώۉ̃L[Ȃ
						// KԂ߂
						DWORD Length = Ope.Time - (*SubjectNoteOn).Time;// Ώۉ̒߂
						float TailRatio = 1.F - ( mTimeBase / 480000.F * Length );// K߂(SȂ48%)
						if ( .05F > TailRatio ) {						// 5%ȉȂ
							TailRatio = .05F;							// 5%Ƃ
						}
						SubjectTailTime = Ope.Time -				// KԁΏۉItԁ|
							static_cast<DWORD>( TailRatio *	Length );// K~Ώۉ̒
						SubjectNoteOff = OpeIt;						// Ώۉm[gIẗʒuL^
						OpeIt = SubjectNoteOn;						// Ώۉm[gÏʒuɖ߂
						Condition = C_SEARCHREPEATNOTE;				// dT
					}
					break;
				}
				break;
			case C_SEARCHREPEATNOTE:	// dT
				switch ( Status ) {									// Cxg
				case 0x90:	// m[gIidj
					if ( 0 < Ope.Status2 ) {						// xVeBOȊOȂ
						if ( SubjectTailTime < Ope.Time ) {			// Kɏd K؂藎Ƃ
							(*SubjectNoteOff).Time = Ope.Time;		// Ώۉ̎Ԃd̎Ԃɐ؂l߂
							(*TrackIt).splice( OpeIt, *TrackIt, SubjectNoteOff );// Ώۉm[gId̒OɈړ
							--OpeIt;								// KRIɂPił܂ߖ߂
							Condition = C_IDLE;						// ԂɈڍs
							cerr << "." << flush;
						} else {									// Sd
							RepeatKey = Ope.Status1;				// d̃L[L^
							list<Operate>::iterator ItWork = OpeIt;	// splicep̃Ce[^ɃZbg
							--OpeIt;								// Ce[^POɑޔ
							RepeatTrack.splice( RepeatTrack.end(), *TrackIt, ItWork );// ̐dpgbNɈڂ
							Condition = C_SEARCHREPEATNOTEOFF;		// dItTԂɈڍs
						}
						break;
					}
					// xVeBOȂm[gItȂ̂Łs
				case 0x80:	// m[gIt
					if ( Ope.Status1 == (*SubjectNoteOn).Status1 ) {// Ώۉ̃L[Ȃ
						Condition = C_IDLE;							// ԂɈڍs
					} else {										// ΏۉȊÕL[Ȃ
						cerr << "dTԂŃm[gIm[gIt܂" << endl;
					}
					break;
				}
				break;
			case C_SEARCHREPEATNOTEOFF:	// dItT
				switch ( Status ) {									// Cxg
				case 0x90:	// m[gI
					if ( 0 < Ope.Status2 ) {						// xVeBOȊOȂ
						break;
					}
					// xVeBOȂm[gItȂ̂Łs
				case 0x80:	// m[gIt
					if ( RepeatKey == Ope.Status1 ) {				// d̃L[Ȃ
						RepeatTrack.splice( RepeatTrack.end(), *TrackIt, OpeIt );// ̐dpgbNɈڂ
						OpeIt = SubjectNoteOn;						// Ώۉm[gÏʒuɖ߂
						Condition = C_SEARCHREPEATNOTE;				// dTԂɈڍs
					}
					break;
				case 0xA0:	// |tHjbNL[vbV[
					if ( RepeatKey == Ope.Status1 ) {				// d̃L[Ȃ
						list<Operate>::iterator ItWork = OpeIt;		// splicep̃Ce[^ɃZbg
						--OpeIt;									// Ce[^POɑޔ
						RepeatTrack.splice( RepeatTrack.end(), *TrackIt, ItWork );// ̐dpgbNɈڂ
					}
					break;
				}
				break;
			}
		}
		++TrackIt;													// gbNCe[^i߂
		// dgbNɂPłĂgbNXgɑ}
		if ( !RepeatTrack.empty() ) {								// dgbN󂶂Ȃ
			cerr << "d܂gbN܂B" << endl;
			RepeatTrack.sort();										// dgbNɃ\[g
			Operate TrackEnd( LastTime, 0xFF, 0x2F );				// gbNGh쐬
			RepeatTrack.push_back( TrackEnd );						// dgbN̍ŌɃgbNGhǉ
			TrackIt = mTrackList.insert( TrackIt, RepeatTrack );	// gbNXgɏdgbN}
			RepeatTrack.clear();									// dgbNNA
		}
	}
}

// e|SgbNɃRs[ --------------------------------------
//	擪gbNɂe|QԈȍ~̃gbNɃRs[
//	Rs[悪̓rꍇ́A𕪒fB
void
Midi::CopyTempoAllTrack ( void )									// m[gGh\ύX
{
	ChengeTimeType( TT_ABSOLUTE );									// ΎԂɕύX
	// 擪gbNe|T
	list<list<Operate>>::iterator FirstTrackIt = mTrackList.begin();// 擪gbN
	for ( list<Operate>::iterator FOpeIt = (*FirstTrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
		  FOpeIt != (*FirstTrackIt).end();							// 䃊Xg̍Ō܂
		  ++FOpeIt ) {												// Ce[^i߂
		Operate &FOpe = *FOpeIt;
		if ( (0xFF != FOpe.Status) || (0x51 != FOpe.Status1) ) {	// e|ȊO
			continue;												// ΏۊO
		}
		list<list<Operate>>::iterator TrackIt = FirstTrackIt;		// ȍ~̃gbN
		// gbNXg[v
		for ( ++TrackIt;											// QԖڂɂ
			  TrackIt != mTrackList.end();							// gbN̍Ō܂
			  ++TrackIt ) {											// Ce[^i߂
			BYTE Note[128] = {0};									// 
			BYTE ch(0);												// ̃gbN̑Ώۃ`l
			// 䃊Xg[v
			for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();// Ce[^ɐ䃊Xg̐擪Zbg
				  OpeIt != (*TrackIt).end();						// 䃊Xg̍Ō܂
				  ++OpeIt ) {										// Ce[^i߂
				Operate &Ope = *OpeIt;
				BYTE Sta = 0xF0 & Ope.Status;						// Cxgo
				// `lo
				if ( 0xF0 != Sta ) {								// SysExȊOȂ
					ch = 0xF & Ope.Status;							// ̃gbÑ`lo
				}
				// e|}ʒumF
				if ( (Ope.Time > FOpe.Time ) ||						// }ʒuȍ~܂
					 ( (Ope.Time == FOpe.Time) &&					// }ʒu
					   ! ( (0x80 == Sta) ||							// im[gIt܂
					     ( (0x90 == Sta) &&							// @m[gI
						   (0x00 == Ope.Status2) ) ) ) ) {			// @xVeBOjȊOȂ
					// m[gIt}
					for ( int Key = 0; Key < 128; ++Key ) {			// SL[`FbN
						if ( Note[Key] ) {							// ̃L[̓rȂ
							Operate OpeNote( FOpe.Time, 0x90 | ch, Key, 0x00);// m[gIt쐬
							OpeIt = (*TrackIt).insert( OpeIt, OpeNote );// m[gIt}
							++OpeIt;								// 䃊Xg̃Ce[^i߂
						}
					}
					// e|}
					OpeIt = (*TrackIt).insert( OpeIt, FOpe );		// e|}
					++OpeIt;										// 䃊Xg̃Ce[^i߂
					// m[gI}
					for ( int Key = 0; Key < 128; ++Key ) {			// SL[`FbN
						if ( Note[Key] ) {							// ̃L[̓rȂ
							Operate OpeNote( FOpe.Time, 0x90 | ch, Key, Note[Key]);// m[gI쐬
							OpeIt = (*TrackIt).insert( OpeIt, OpeNote );// m[gI}
							++OpeIt;								// 䃊Xg̃Ce[^i߂
						}
					}
					break;											// ̃gbN
				}
				// ԊmF
				switch ( Sta ) {									// Cxg
				case 0x90:	// m[gI
					if ( 0x00 != Ope.Status2 ) {					// xVeBOłȂ
						Note[ Ope.Status1 ] = Ope.Status2;			// m[gI
						break;
					}		// xVeBOȂm[gItȂ̂ős
				case 0x80:	// m[gIt
					Note[ Ope.Status1 ] = 0;						// m[gIt
					break;
				}
			}
		}
	}
}
// S\
void
Midi::PrintAllOperate ( void )										// S\
{
	// gbNXg[v
	int TrackNo(0);
	for ( list<list<Operate>>::iterator TrackIt = mTrackList.begin();// Ce[^ɃgbNXg̐擪Zbg
		  TrackIt != mTrackList.end();								// gbN̍Ō܂
		  ++TrackIt, ++TrackNo ) {									// Ce[^i߂
		cerr << "Track " << TrackNo << ":";
		// 䃊Xg[v
		for ( list<Operate>::iterator OpeIt = (*TrackIt).begin();	// Ce[^ɐ䃊Xg̐擪Zbg
			  OpeIt != (*TrackIt).end();							// 䃊Xg̍Ō܂
			  ++OpeIt ) {											// Ce[^i߂
			Operate &Ope = *OpeIt;
			cerr << "(" << hex
				<< Ope.Time << ","
				<< (WORD)Ope.Status << ","
				<< (WORD)Ope.Status1 << ","
				<< (WORD)Ope.Status2 << ")" << flush;
		}
		cerr << endl;
	}
}
