#ifndef _MIDI
#define _MIDI
#include <list>
using namespace std;

// MIDINX
class Midi {
protected:
	// midi file headers
	struct FileHeader {
		DWORD	dwKeyWord;				// "MThd"
		DWORD	dwMainHeaderSize;		// MainHeader size
	};
	struct MainHeader {
		WORD	wFormat;				// midi format 0/1
		WORD	wTrackCount;			// track count
		WORD	wTimeBase;				// \F4Ƃ鐔l(480ʓI)
	};
	struct TrackHeader {
		DWORD	dwKeyWord;				// "MTrk"
		DWORD	dwTrackSize;			// track size
	};
	enum {
		FHSIZE = sizeof( FileHeader ),
		MHSIZE = sizeof( MainHeader ),
		THSIZE = sizeof( TrackHeader),
	};
public:
	// NX
	class Operate {						// NX
	public:
		DWORD	Time;					// O̐䂩̎
		BYTE	Status;					// Xe[^X
		BYTE	Status1;				// Xe[^X1
		BYTE	Status2;				// Xe[^X2
		string	ExData;					// VXeGNXN[VubZ[W
		// RXgN^
		Operate(						// RXgN^ŏ
			DWORD	_Time	= 0,
			BYTE	_Status	= 0x00,
			BYTE	_Status1= 0x00,
			BYTE	_Status2= 0x00,
			string	_ExData	= "")
		:	Time	(_Time),
			Status	(_Status),
			Status1	(_Status1),
			Status2	(_Status2),
			ExData	(_ExData) {}
		// Iy[^[	(list::sortlist::mergegp)
		bool operator < (
			const Operate &Ope) {
			// ΎԂɂ蔻肷邪Ԃ̏ꍇ̓`lŔ肷
			return ( (Time < Ope.Time)? TRUE: ( (Time > Ope.Time)? FALSE: ((0xf & Status) < (0xf & Ope.Status)) ) );
			//return ( Time < Ope.Time );
		}
/* Ȃ̂ł߂
		// Iy[^[	(list::removegp)
		bool operator == (
			const Operate &Ope) {
			// Xe[^XʂɈv𔻒肷
			if ( Status != Ope.Status ) return FALSE;	// Xe[^XႤ
			switch ( 0xF0 & Status ) {
			// oCg
			case 0xF0:	// VXeGNXN[VubZ[W
				if ( 0xFF == Status ) {	// ^CxgȂ
					if ( Status1 != Ope.Status1 ) return FALSE;	// Xe[^XPႤ
				}
				if ( ExData != Ope.ExData ) return FALSE; // VXeGNXN[VubZ[WႤ
				break;
			// 3ByteStatus
			case 0x80:	// m[gIt
			case 0x90:	// m[gI
			case 0xA0:	// |tHjbNL[vbV[
			case 0xB0:	// Rg[`FW
			case 0xE0:	// sb`xh
				if ( Status2 != Ope.Status2 ) return FALSE;	// Xe[^XQႤ
				// breaks
			// 2ByteStatus
			case 0xC0:	// vO`FW
			case 0xD0:	// `lvbV[
				if ( Status1 != Ope.Status1 ) return FALSE;	// Xe[^XPႤ
			//default:	// ȊOُ͈ȃXe[^XȀꍇXe[^X݂̂̔Ƃ
			}
			return TRUE;				// vƔF߂
		}
*/
	};
	// oϐ
	WORD		mFormat;				// midi format 0/1
	WORD		mTimeBase;				// \
	enum TIMETYPE {						// ԃ^Cv񋓌^
		TT_RELATIVE,					// @Ύ
		TT_ABSOLUTE,					// @Ύ
	}			mTimeType;				// ԃ^Cv FALSE:Ύ TRUE:Ύ
	list<list<Operate>> mTrackList;		// gbNf[^
	// RXgN^
	Midi():								// RXgN^
		mFormat(),
		mTimeBase(),
		mTimeType(),
		mTrackList() {}
	Midi(								// t@CtRXgN^
		const char		*FilePath ):	// (i)SMFt@CpX
		mFormat(),
		mTimeBase(),
		mTimeType(),
		mTrackList() {
		Load( FilePath );				// [h
	}
	// fXgN^
	~Midi(){}
	// [h
	int Load (							// SMFǂݍ
		const char		*FilePath );	// (i)t@CpX
	// Z[u
	int Save (							// SMFo
		const char		*FilePath );	// (i)t@CpX
	// ԐLk
	void TimeExpand (					// gbN̎ԂLk
		const float		&Ratio );		// (i)Lk
	// \ύX
	void ChangeResolution (				// \ύX
		const WORD	&NewTimeBase );		// (i)V\
	// tH[}bgύX
	void ChengeFormat (					// tH[}bgύX
		const WORD		&Format );		// (i)tH[}bg
	// ԃ^CvύX
	void ChengeTimeType (				// ԃ^CvύX
		const TIMETYPE	&NewTimeType );	// (i)Vԃ^Cv
	// SysEx폜
	void DeleteSysEx (					// SysEx폜
		const WORD		Mode = 0x3 );	// (i)SysEx폜[h
	// gp폜
	void DeleteUnusedOperate ( void );	// gp폜
	// gbN폜
	void DeleteEmptyTrack ( void );		// gbN폜
	// m[gGh\ύX
	void ChengeNoteEndType (			// m[gGh\ύX
		const WORD   NewNoteEnd = 0x90);// (i)Vm[gGh\ 0x80 / 0x90
	// dgbN
	void DivideRepeatNote (	void );		// dgbN
	// e|SgbNɃRs[
	void CopyTempoAllTrack ( void );	// m[gGh\ύX

	// S\
	void PrintAllOperate ( void );		// S\
protected:// ֐
	// gbN
	int Decode (						// t@CXg[ǂݍ݃gbN͂
		istream			&is,			// (i)̓Xg[
		const DWORD		&TrackSize);	// (i)gbNTCYigbN̏Iʒuɗpj
	// f^^C
	DWORD TimeDecode (					// t@CXg[ǂݍ݃f^^C͂ԂԂ
		istream			&is);			// (i)̓Xg[
	// gbN
	int Encode(							// gbNf[^𕄍Xg[ɏo͂
		ostream			&os,			// (o)o̓Xg[
		list<Operate>	&OpeList);		// (i)䃊Xg
	// f^^C
	int TimeEncode (					// Ԃf^^CɕXg[ɏo͂
		ostream			&os,			// (o)o̓Xg[
		DWORD			Time);			// (i)
	// SgbNGh폜
	DWORD DeleteAllTrackEnd ( void );	// SgbNGh폜AyуgbNŌ̎Ԃ̎
	void  AppendAllTrackEnd (			// SgbNgbNGhǉ
		const DWORD		&LastTime );	// (i)gbNGh
};
#endif	// MIDI
